import hou
import re

def goOnStage( node, lopNode) :
    stage = hou.node('/stage') 
# check if node exists
    nodePath = '/stage/%s/sopnet/create/merge_%s'%(node.name(), node.name())
    update = hou.node(nodePath) != None    
    if update == 1:
        hou.node(nodePath).parm('objpath1').set(lopToStage.path())
        lopNode = hou.node( '/stage/%s'%node.name())
    else :        
#create sop import        
        lopNode = stage.createNode( 'sopcreate', node.name())
        lopNode.allowEditingOfContents(True)
        sopNode = hou.node(lopNode.path() + '/sopnet/create/')
        merge = sopNode.createNode('object_merge', 'merge_%s'%node.name())    
        merge.parm('numobj').set(1)
        merge.parm('objpath1').set(lopToStage.path())
        merge.parm('xformtype').set(1)
    
#rename from soppath
        wrangle = sopNode.createNode('attribwrangle', 'naming_%s'%node.name())
        wrangle.parm('class').set(1)
        expression = 'string names[] = re_split(\'/\', s@shop_materialpath);\ns@name = names[len(names)-1];\n'
        wrangle.parm('snippet').set(expression)    
        wrangle.setInput(0, merge)
    
        null = sopNode.createNode('null', 'OUT_%s'%node.name())
        null.setInput(0, wrangle)
        null.setGenericFlag(hou.nodeFlag.Render, 1)
        null.setGenericFlag(hou.nodeFlag.Display, 1)
        lopNode.matchCurrentDefinition()
        lopNode.parm('enable_partitionattribs').set(0)    
        lopNode.parm('enable_customattribs').set(1)      
        lopNode.parm('customattribs').set('shop_materialpath')

#create material library
    nodePath = '/stage/matos_%s'%node.name()
    update = hou.node(nodePath) != None 
    if update :
        matNames = []
        matlib = hou.node(nodePath)
        children = matlib.children()
        for ch in children: 
            matNames.append(ch.name())
    else :
        matlib = stage.createNode('materiallibrary', 'matos_%s'%node.name())
        matlib.setInput(0, lopNode)
        matNames = []

    if lopToStage.geometry() == None:
        print('object %s COULD NOT find geometry'%node.name())
        return lopNode
        
    if( lopToStage.geometry().findPrimAttrib('shop_materialpath') == None) :
        parms = node.parms()
        for parm in parms:
            if re.match("shop_materialpath", parm.name()):
                matPath = parm.eval()
                found = (len(matPath) == 0)
                res = []
                for m in range( len(matNames)):
                    res = re.findall( matNames[m], matPath)
                if( len(res) > 0) :
                    found = 1
                if( found == 0) :
                    newMath = hou.node(matPath).copyTo(matlib)
                    print('name : %s'%newMath.name())
                    matNames.append(newMath.name())
    else :
        prims = lopToStage.geometry().prims()    
        for pr in prims:
            matPath = pr.stringAttribValue('shop_materialpath')
            found = (len(matPath) == 0)
            res = []
            for m in range( len(matNames)):
                res = re.findall( matNames[m], matPath)
                if( len(res) > 0) :
                    found = 1
            if( found == 0) :
                newMath = hou.node(matPath).copyTo(matlib)
                print('name : %s'%newMath.name())
                matNames.append(newMath.name())

# assign matyerial wrangle
    if update == 0:
        wrangle = stage.createNode('attribwrangle', 'assign_%s'%node.name())
        wrangle.setInput(0, matlib)
#    expression = 'string model =  chs(\"primitives\");\n'
#    expression+= 'string matLib = chs(\"matLib\");\n'
        expression = 'string model =  chs(\''+lopNode.path() + '/pathprefix\');\n'
        expression+= 'string matLib = chs(\'' + matlib.path() +'/matpathprefix\');\n'
        expression+= 'string mat[] = usd_childnames(0, \"/materials\");\n'
        expression+= 'string groups[] = usd_childnames(0, model);\n'
        expression+= 'foreach( string gr ;groups) {\n'
        expression+= '\tstring grN = model +"/" + gr;\n'
        expression+= '\tstring path[] = usd_attrib(0, grN,  \"shop_materialpath\", 0);\n'
        expression+= '\tif( len(path) > 0) {\n'
        expression+= '\t\tstring basename[] = re_split( \"/\", path[0]);\n'
        expression+= '\t\tif( len(basename) != 0) {\n'
        expression+= '\t\tstring matos = \"/materials/\" + basename[len(basename)-1];\n'
        expression+= '\t\tusd_setrelationshiptargets(0, grN, \"material:binding\", array(matos));\n'
        expression+= '\t\t}\n'
        expression+= '\t}\n'
        expression+= '\n}'
        wrangle.parm('snippet').set(expression) 
#    wrangle.allowEditingOfContents(True)
# #   folder = wrangle.parmTemplateGroup().findFolder('Code')
#    groupParam = wrangle.parmTemplateGroup()
#    primParm = hou.StringParmTemplate('primitives', 'primitives', 1);
#    matLibParm = hou.StringParmTemplate('matlib', 'matlib', 1);
#    folder = hou.FolderParmTemplate('folder_generatedparms_snippet', 'Generated Channel Parameters')
#    folder.addParmTemplate(primParm)
#    folder.addParmTemplate(matLibParm)
#    groupParam.append(folder)
#    wrangle.setParmTemplateGroup(groupParm)
    return lopNode    
    

selected = hou.selectedNodes()
if len(selected) == 0:
    hou.ui.displayMessage('Please select Geo Nodes')
    
for node in selected:
    print('---------------%s-----------------'%node.name())
    type = node.type().nameWithCategory()
    print(type)
    lopToStage = ''
    yes = 0
    if( re.match('Object/geo', type)) :
        yes = 1
        children = node.children()
        for ch in children:
            if( ch.isGenericFlagSet(hou.nodeFlag.Render)) :
                lopToStage = ch
    if( re.match('Sop', type)):
        yes = 1
        lopToStage = node
    if yes == 1:
        lopNode = goOnStage(node, lopToStage)
        print('lop %s'%lopNode.name()) 